package com.vertigrated.oss.jackson.extjs.treestore;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.vertigrated.oss.extjs.treestore.ValueNode;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

public class ValueNodeSerializer extends JsonSerializer<ValueNode>
{
    private static final Logger L = LoggerFactory.getLogger(ValueNodeSerializer.class);

    @Override
    public void serialize(ValueNode value, JsonGenerator jgen, SerializerProvider serializers) throws IOException
    {
        jgen.writeStartObject();
        jgen.writeStringField("id", value.id);
        jgen.writeStringField("name", value.name);
        jgen.writeStringField("type", value.type.getSimpleName());
        jgen.writeBooleanField("leaf", value.leaf);
        if (value.type.equals(Date.class))
        {
            final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'hh:mm:ssZ");
            sdf.setTimeZone(TimeZone.getTimeZone("UTC"));
            jgen.writeStringField("value", sdf.format(value.value));
        }
        else
        {
            jgen.writeStringField("value", String.valueOf(value.value));
        }
        jgen.writeEndObject();
    }
}
